// async.cpp
//

#include "stdafx.h"
#include "async.h"

CAsyncClass::CAsyncClass() :m_dwError(0L),m_bComplete(true)
{
}

CAsyncClass::~CAsyncClass() 
{
}

void CAsyncClass::SetError(DWORD dw)
{
	m_dwError=dw; 
}

DWORD CAsyncClass::GetError()
{
	return m_dwError;
}

void CAsyncClass::SetComplete(bool b)
{
	m_bComplete=b;
}

DWORD WINAPI AsyncThread(LPVOID lpVoid)
{
	CoInitialize(NULL);

	CAsyncClass* p=(CAsyncClass*)lpVoid;
	p->OnRequestData();
	p->SetComplete(true);

	CoUninitialize();

	return 0L;
}

void CAsyncClass::DoRequestData()
{
	m_dwError=0L;
	m_bComplete=false;

	HANDLE hThread;
	DWORD  dwThreadID;

	hThread=CreateThread(NULL,0,AsyncThread,(LPVOID)this,0,&dwThreadID);

	bool bQuit=false;

	while(!m_bComplete) 
	{ 
		MSG msg;
		while(!bQuit && PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)) 
		{ 
			bQuit=(bQuit || msg.message==WM_QUIT);

			if(msg.message!=WM_QUIT)
			{
				if(GetMessage(&msg,NULL,0,0)>0)
				{
					TranslateMessage(&msg);
					DispatchMessage(&msg);            
				}
			}
		}
	}

	WaitForSingleObject(hThread,INFINITE);
	CloseHandle(hThread);

	if(!bQuit)
		OnNotifyComplete();
}